#ifndef PARSE_H
#define PARSE_H

/* եѥ

 Visual-C++ξ硢ʲΥܥ뤬Ƥ
	_MSC_VER
 MingWin32ξ硢ʲΥܥ뤬Ƥ
	__MINGW32__
 Borland C++5.51ξ硢ʲΥܥ뤬Ƥ
	__BORLANDC__
 MingWin32ξ硢ʲΥܥ뤬Ƥ
	__MINGW32__
 gcc
        __GNUC__
 gcc(g++)
        __GNUG__
 ANSI C++ɥեȤǤ׵ᡢߤ׵ᤵƤʤ
        __cplusplus
*/

#include <vector>
#include <string>
#include <list>

class tagrec {
public:
  bool issingle;
  size_t offset; // ƤΥƥȤƬΥեå
  std::string label;
  std::string value;
  std::list<std::pair<std::string, std::string> > attrs;
  std::list<tagrec *> child;
  tagrec *owner;
  tagrec(): owner(0), offset(0), issingle(true) {}
  ~tagrec();
  bool tagcmp(const std::string &s);
  bool scanattr(std::pair<std::string, std::string> &v,
   const std::string &s);
  int scan(std::vector<tagrec *> &ls, const std::string &s);
  int path(std::vector<tagrec *> &ls, const std::string &s);
  int find(std::vector<tagrec *> &ls, const std::string &s);
  tagrec *findroot();
  std::string dump();
};

// XHTMLǤ<br />ʤɤϿƤΥƥǤΰ֤ˤʤ
// ξˤoffsetǰ֤򻲾Ȥ

class parser {
public:
  enum states {
    none =  0,
    stag =  1,
    etag =  2,
    text =  3,
    stop =  4,
    eps1 = 10,
    eps2 = 11,
    eps3 = 12,
    com1 = 20,
    com2 = 21,
    com3 = 22,
    decl = 30,
    pis1 = 40,
    pis2 = 41,
    cdt1 = 50,
    cdt2 = 51,
    cdt3 = 52,
    cdt4 = 53,
    cdt5 = 54,
    cdt6 = 55,
    cdt7 = 56,
    cdt8 = 57,
    cdt9 = 58,
  } state;
private:
  std::string buff;
  int quote;
  int pnone(int c);
  int pstag(int c);
  int petag(int c);
  int ptext(int c);
  int peps1(int c);
  int peps2(int c);
  int peps3(int c);
  int pcom1(int c);
  int pcom2(int c);
  int pcom3(int c);
  int pdecl(int c);
  int ppis1(int c);
  int ppis2(int c);
  int pcdt1(int c);
  int pcdt2(int c);
  int pcdt3(int c);
  int pcdt4(int c);
  int pcdt5(int c);
  int pcdt6(int c);
  int pcdt7(int c);
  int pcdt8(int c);
  int pcdt9(int c);
  std::list<std::string> septag();
  void enter(enum states state);
  void leave(enum states state);
  int checknext(bool b, enum states next);
public:
  tagrec *root;
  tagrec *bp;
  parser(): root(0), bp(0), state(none) {}
  bool acceptable();
  bool checkerror();
  int step(int c);
};

#endif
